package com.iceberg;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
import javax.microedition.lcdui.*;

/**
 * @author DDDEN!SSS
 */
public final class G3D { //Graphics3D
    
    private static Element3D temp;
    private static final int[] d = {1, 4, 10, 23, 57, 145, 356, 911, 1968, 4711, 11969, 27901, 84801, 213331, 543749, 1355339, 3501671, 8810089, 21521774, 58548857, 157840433, 410151271, 1131376761, 2147483647};
    
    public static int centreX,  centreY; //центр дисплея
    private static final float pers = 1.5f; //перспектива
    public static int persX = 150; //перспектива
    public static int persY = 150; //перспектива
    public static int range = 1500; //дальность рендеринга

    
    private static Element3D[] ZBuffer = new Element3D[1000]; //массив для элементов
    private static int ZBufferSize = 0; //количество линий в массиве


    public static void setCentre(int x, int y) {
        centreX = x;
        centreY = y;
        persX = (int) (centreX * pers);
        persY = (int) (centreY * pers);
    }

    public static void addFigure(Figure figure) {
        for (int i = 0; i < figure.element.length; i++) {
            if (ZBufferSize < ZBuffer.length) { //если ZBuffer не переполнен
                if (figure.element[i].ifVisible()) { //если елемент виден
                    ZBuffer[ZBufferSize] = figure.element[i]; //
                    ZBufferSize++;                             //добавляем элемент
                }
            }
        }
    }

    public static void removeAll() {
        ZBufferSize = 0;
    }

    public static void render(Graphics g) {
        sort_shell(ZBuffer, ZBufferSize);
        
        for (int i=ZBufferSize-1; i >= 0; i--) {
            ZBuffer[i].paint(g);
        }
    }

    public static final void sort_shell(Element3D[] a, int b) {
        int i, j, k, m = 0;
        while(d[m] < b) {
            ++m;
        }
        while(--m >= 0) {
            k = d[m];
            for(i = k; i < b; i++) { // k-сортировка
                j = i;
                temp = a[i];
                while((j >= k) && (a[j-k].sz > temp.sz)) {
                    a[j] = a[j - k];
                    j -= k;
                }
                a[j] = temp;
            }
        }
    }
}